package jp.ne.motoki.android.hellolivewallpaper;

import static jp.ne.motoki.android.hellolivewallpaper.Utils.log_debug;
import static jp.ne.motoki.android.hellolivewallpaper.Utils.log_error;
import android.app.AlertDialog;
import android.content.ActivityNotFoundException;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.os.Bundle;
import android.preference.Preference;
import android.preference.Preference.OnPreferenceClickListener;
import android.preference.PreferenceActivity;
import android.preference.PreferenceManager;

public class HelloWallpaperSettings extends PreferenceActivity {
	
	private static boolean unitTestMode = false;
    
    private static final int REQUEST_PICK_IMAGE = 4649;
    private Preference imagePreference = null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        addPreferencesFromResource(R.xml.settings);
        
        // TODO magic code
        imagePreference = getPreferenceScreen().getPreference(0);
        imagePreference.setOnPreferenceClickListener(
        		new OnPreferenceClickListener() {

			public boolean onPreferenceClick(Preference preference) {
				log_debug("onPreferenceClick : preference = "
						+ preference.getTitle());
				try {
					requestPickImage();
				} catch (ActivityNotFoundException e) {
					log_error("An exception occured at requestPickImage", e);
					showGalleryNotFoundDialog();
				}
				return true;
			}
        	
        });
    }

    @Override
	protected void onDestroy() {
		super.onDestroy();
	}

	@Override
    protected void onActivityResult(
    		int requestCode, int resultCode, Intent data) {
    	
        super.onActivityResult(requestCode, resultCode, data);
        
        String message = String.format(
        		"requestCode = %d : resultCode = %d", requestCode, resultCode);
        log_debug(message);
        
        // TODO magic code
        if (requestCode == REQUEST_PICK_IMAGE && resultCode == -1) {
            PreferenceManager manager = getPreferenceManager();
            SharedPreferences prefs = manager.getSharedPreferences();
            String imageUri = data.getDataString();
            Editor editor = prefs.edit();
            editor.putString(getString(R.string.key_image), imageUri);
            log_debug("committion = " + editor.commit()
            		+ " : Uri = " + imageUri);
        }
    }
	
	/**
	 * @throws ActivityNotFoundException
	 */
	private void requestPickImage() {
        Intent intent = new Intent(Intent.ACTION_PICK);
        String type = String.format("%s/*", unitTestMode ? "hoge" : "image");
        intent.setType(type);
        startActivityForResult(intent, REQUEST_PICK_IMAGE);
	}
	
	private void showGalleryNotFoundDialog() {
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		// TODO Hard cording
		builder.setTitle("Error");
		builder.setMessage("Gallery is not found");
		builder.setPositiveButton("OK", null);
		builder.create().show();
	}

}
